/*jslint white: true */
/*global Drupal $ document jQuery */

$(document).ready(function () {
  var amount = 0;
  var alltabs = [];
  //generate the tabs
  jQuery.each(Drupal.settings.WebFormAjaxPage.forms, function () {
    var wrapper = this.wrapper;
    var id = this.id;
    var hide_submit = parseInt(this.hide_submit, 10);
    alltabs[id] = $("#" + wrapper).tabs({idPrefix: 'ui-tabs-' + amount});

    //get the amount of tabs
    var totalSize = $("#" + wrapper + " .webform-component-ajax-page").size() - 1;
    //hide submit button initially
    $('#' + id).parents().find('form').find(' .form-actions input').each(function () {
      if (hide_submit && !$(this).hasClass('cancel') && !$(this).is('#edit-draft')) {
        $(this).hide();
      }
    });
    amount += 1;

    //add the next and previous links
    $("#" + wrapper + " .webform-component-ajax-page").each(function (i) {
      var $self = $(this);
      var html = '<div class="webform-ajax-page-nav">';

      if (i !== 0) {
        var prev = i - 1;
        html += "<a href='#' class='prev-tab mover' rel='" + prev + "'>" + Drupal.settings.WebFormAjaxPage.labels[$self.attr('id')].previous + "</a>";
      }

      if (i !== totalSize) {
        var next = i + 1;
        html += "<a href='#' class='next-tab mover' rel='" + next + "'>" + Drupal.settings.WebFormAjaxPage.labels[$self.attr('id')].next + "</a>";
      }
      html += '</div>';
      $self.append(html);
    });

    //next and previous links handlers
    $("#" + wrapper + ' .next-tab, #' + wrapper + ' .prev-tab').click(function (e) {
      if ($(this).hasClass('next-tab') && typeof (Drupal.settings.clientsideValidation) !== 'undefined') {
        if ($('#' + $(this).parents().find('form').attr('id')).valid()) {
          alltabs[$(this).parents().find('form').attr('id')].tabs('select', parseInt($(this).attr("rel"), 10));
        }
      }
      else {
        alltabs[$(this).parents().find('form').attr('id')].tabs('select', parseInt($(this).attr("rel"), 10));
      }
      if ($(this).hasClass('prev-tab') && typeof (Drupal.settings.clientsideValidation) !== 'undefined') {
        $('.messages.error.clientside-error').hide();
      }
      hideOrShow(alltabs[$(this).parents().find('form').attr('id')], $(this).parents().find('form').attr('id'), totalSize, hide_submit);
      var x = $('#' + wrapper).offset().top - 100;
      $('html, body').animate({scrollTop: x}, 1000);
      e.preventDefault();
    });
    if (hide_submit) {
      $('#' + id + ' #edit-actions').appendTo($('#' + id + ' .webform-component-ajax-page .webform-ajax-page-nav'));
    }
  });

  function hideOrShow($tabs, wrapperid, size, hide_submit) {
    if ($tabs.tabs('option', 'selected') !== size) {
      $('#' + wrapperid + ' .form-actions input').each(function () {
        if (hide_submit && !$(this).hasClass('cancel') && !$(this).is('#edit-draft')) {
          $(this).hide();
        }
      });
    }
    else {
      $('#' + wrapperid + ' .form-actions input').each(function () {
        if (!$(this).hasClass('cancel')&& !$(this).is('#edit-draft')) {
          $(this).show();
        }
      });
    }
  }

});
